Subject: bug#59738: c-ts-mode is slow with large buffers.

From: Eli Zaretskii <[email-masked]>
Date: Sun, 11 Dec 2022 19:38:24 +0200

> Date: Sun, 11 Dec 2022 17:13:49 +0000
> Cc: [email-masked], [email-masked]
> From: Alan Mackenzie <[email-masked]>
> 
> > You do all your measurements in an optimized build of Emacs.  I did
> > mine in an unoptimized build, something that I need to use all the
> > time, even though my production sessions run optimized builds.  In an
> > unoptimized build CC Mode is extremely slow.
> 
> I've built an emacs-29 with CFLAGS='-O0 -g3', --with-native-compilation,
> and --with-enable-checking=all.  Just about anything is slow in such a
> build.  For example, converting the org mode manual from .org to .texi
> took ~15 minutes in the bootstrap.

The time it takes to build the Org manual doesn't bother me, since it
is rarely redone, and is not part of my maintenance job.  Also, in my
builds I get to producing the Org manual when the Lisp files are
already byte-compiled, so it takes much less than 15 min.  And
finally, I almost never bootstrap.

> Do you really need to run in such a build all the time?

It is impossible to debug Emacs efficiently on the C level using the
optimized build.  So yes, I'm using unoptimized builds quite a lot.

> > For example, just visiting dce_12_0_sh_mask.h file takes a whopping 67
> > sec, and M-> immediately after the file is displayed takes another 25
> > sec.  With c-ts-mode, these numbers are, respectively, 1.8 sec and 2
> > sec.
> 
> Yes.  I saw pretty much the same in my pessimised build.  In a normal
> build, these operation are ~10 times as fast.  Also we're all agreed
> dce_12_0_sh_mask.h is an unusual file, both in its content and its size.

If it is an unusual file, why did you report the slow scrolling
through it as a bug?  We need to be consistent: either that file is
legitimate and Emacs should work reasonably fast with it, or it isn't.

> If I remember rightly, speed was one of the main reasons given for
> introducing tree-sitter, though I may well be wrong here.

Not from my POV, no.  It's an important factor, but not the main
reason.

> > Speed is not the main reason why we want to have font-lock and
> > indentation based on a parser library.  The main reason is
> > _correctness_ and _accuracy_.  A regexp-based fontification and
> > indentation engines will never be able to match parser-based engines,
> > because they doesn't really understand the source code.
> 
> Given the current CC Mode, any increase in correctness is going to be
> marginal, if apparent at all.

I disagree.  Both C and C++ are still evolving, and their syntax and
semantics don't become simpler.  People post bug reports against CC
Mode which involve some tricky syntactical constructs all the time.
Our current font-lock is just a huge collection of ad-hocery, and
there's a limit to what we can do with ad-hoc code.  Personally, I
think this is an evolutionary dead end.  It was acceptable years ago,
when the incremental parsing technology was not developed enough
and/or not accessible easily enough.

> > Even when aided by syntax-ppss, they only catch some part of the
> > syntax, and none of the semantics.
> 
> c-forward-decl-or-cast-1 and friends do analyze semantics

A small part of it.

> > The hope is that using a parser will allow us to provide much more
> > accurate implementations.  Whether and how much this hope will
> > materialize is yet to be seen, but looking just at the speedup is
> > definitely not TRT for assessing the success of this development in
> > Emacs.
> 
> I see the advantage of the new tree sitter modes more in a reduction of
> maintenance burden (though few other people will see this with respect to
> CC Mode ;-).

That too.